(function (app) {

    app.localize = function (key) {
        return translations[key];
    };

    var translations = {
        'changes are saved': 'All changes are saved',
        'changes are not saved': 'Changes have NOT been saved. Please reload the page and change the settings again. Contact support@easygenerator.com if problem persists.',
        'settings are not initialize': 'Template settings are not initialized. Please reload the page and change the settings again. Contact support@easygenerator.com if problem persists.',

        //general settings tab
        'general settings': 'General Settings',
        'pdf export': 'PDF export (experimental):',
        'show download as pdf button': 'Show button "Download course in PDF format"',
        'conduct learner satisfaction survey': 'Conduct learner satisfaction survey',
        'allow users to download certificates': 'Allow users to download certificates',
        'available when save progress disabled hint': 'Is not available when ‘save progress cross device’ is disabled',

        //results tracking tab
        'results tracking': 'Results Tracking',

        'lrs': 'LRS',
        'webhooks': 'Webhooks',

        'chooseLrsLabel': 'Choose LRS <span>(Learning Record Store <a href="https://help.easygenerator.com/results-tracking/results-tracking-via-lrs" target="_blank">Learn more</a>)</span>',
        'default': 'easygenerator (recommended)',
        'custom': 'Custom LRS',

        'addWebhookEndpoinLabel': 'Add a webhook endpoint:',
        'webhookUrlLabel': 'URL to be called',
        'urlCheckButtonText': 'Check URL',
        'checkErrorMessage': 'An error appears',
        'checkSuccessMessage': 'URL successfully reached',

        'track and trace settings': 'Track and trace settings',
        'results tracking option': 'Results tracking:',
        'results tracking hint': '(will not affect tracking and tracing in SCORM/LMS)',
        'allow user to skip option': 'Allow user to skip tracking and tracing:',
        'allow scoring of content pages': 'Allow scoring of content pages:',
        'show confirmation popup': 'Show confirmation dialogue:',
        'show confirmation popup hint': '(when submitting final results)',
        'disabled': 'Disabled',
        'enabled': 'Enabled',
        'allow': 'Allow',
        'forbid': 'Forbid',
        'hide': 'Hide',
        'show': 'Show',
        'advanced settings': 'Advanced settings',
        'report to': 'Report to:',
        'custom lrs settings': 'Custom LRS settings',
        'lrs url': 'LRS URL',
        'authentication required': 'Authentication required',
        'lap login': 'LAP login',
        'lap password': 'LAP password',
        'use statements': 'Use statements:',
        'started': 'Started',
        'stopped': 'Stopped',
        'passed': 'Passed',
        'answered': 'Answered',
        'mastered': 'Mastered',
        'experienced': 'Experienced',
        'failed': 'Failed',
        'progressed': 'Progressed',
        'save progress cross device': 'Save progress cross device (requires login and password):',
        'save progress cross device hint': '(will not affect progress saving in SCORM/LMS)',
        'allow social media': 'Allow login via social media',
        'authorsBioTooltip': 'This information will be shown to learners on the introduction page <a href="http://help.easygenerator.com/getting-started/billing-info-and-account-settings" target="blank" >Learn more</a>',
        'about the author block:': '\'About the author\' block:',
        'show about the author block on the introduction course page': 'The \'About the author\' block on the introduction course page',
        'information is taken from your profile settings': '(NOTE: the information is taken from your  <a href="/#accountsettings" target="_parent">profile settings</a>)',

        //mastery score
        'mastery score settings': 'Mastery score settings',
        'mastery score caption': 'Mastery score:',
        'mastery score hint': '(for each learning objective):',
        'mastery score will for': 'Mastery score will be set:',
        'mastery score means' : 'Mastery score is the score learners have to reach to pass the course successfully',
        'overall course caption' : 'For the entire course',
        'mastery score' : 'Mastery score:',
        'each section caption' : 'For each section',

        //template language
        'template language': 'Template language',

        'xx': 'Custom',
        'cn': 'Chinese',
        'de': 'German',
        'da': 'Danish',
        'en': 'English',
        'fr': 'French',
        'it': 'Italian',
        'nl': 'Dutch',
        'nl-inf': 'Dutch (informal)',
        'tr': 'Turkish',
        'ua': 'Ukrainian',
		'es': 'Spanish',
		'pt-br': 'Portuguese (Brazil)',
		'ru': 'Russian',
		'ms': 'Malay',
		'kr': 'Korean',
		'nb-no': 'Norwegian (Bokmal)',
		'nn-no': 'Norwegian (Nynorsk)',
        'vi': 'Vietnamese',
        'fa': 'Farsi',
        'sv': 'Swedish',
        'pl': 'Polish',
        'kin': 'Kinyarwanda',
        'ca': 'Catalan',
        'ar': 'Arabic',
        'ro': 'Romanian',
        'cs': 'Czech',
        'fi': 'Finnish',
        'el': 'Greek',
        'lv': 'Latvian',
        'hu': 'Hungarian',
        'bg': 'Bulgarian',
        'sl': 'Slovenian',

        'choose language for your course': 'Choose language for your course',
        'defaultText': 'Default',
        'translation': 'Translation',
        'copyright text': 'Copyright text:',
        'copyrightPlaceholder': 'Copyright © {year} Easygenerator'
    };

})(window.app = window.app || {});

(function () {
    ko.bindingHandlers.number = {
        init: function (element) {
            var $element = $(element),
                maxValue = 100;
            $element.on('keydown', function (e) {
                var key = e.charCode || e.keyCode || 0;
                return (key == 8 || key == 9 || key == 46 || (key >= 37 && key <= 40) ||
                    (key >= 48 && key <= 57) || (key >= 96 && key <= 105));
            });
            $element.on('keyup', function () {
                if ($(this).val() > maxValue) {
                    $(this).val(maxValue);
                }
            });
        }
    };

    ko.bindingHandlers.disableDragNDrop = {
        init: function (element) {
            $(element).on('dragstart', function (event) {
                event.preventDefault();
            });
        }
    };

    ko.bindingHandlers.spinner = {
        init: function (element, valueAccessor) {
            var masteryScore = valueAccessor();
            $(element).spinner('changing', function (e, newValue) {
                masteryScore(newValue);
            });

        }
    };

    ko.bindingHandlers.switchToggle = {
        init: function (element, valueAccessor) {
            var switchToggle = ko.bindingHandlers.switchToggle,
                viewModel = switchToggle.viewModel(element, valueAccessor),
                value = ko.unwrap(valueAccessor().value()),
                onBeforeValueUpdated = valueAccessor().onBeforeValueUpdated;

            viewModel.setInitialValue(value);

            switchToggle.onClick(element, function () {
                var currentValue = ko.unwrap(valueAccessor().value());
                var newValue = !currentValue;
                if(onBeforeValueUpdated && !onBeforeValueUpdated(newValue)){
                    return;
                }

                viewModel.toggle();
                valueAccessor().value(newValue);
            });
        },
        update: function (element, valueAccessor) {
            var viewModel = ko.bindingHandlers.switchToggle.viewModel(element, valueAccessor),
                value = ko.unwrap(valueAccessor().value());

            viewModel.updateValue(value);
        },
        viewModel: function (element) {
            var $element = $(element),
                $wrapper = $('.switch-toggle-wrapper', $element);

            function setInitialValue(value) {
                setElementValue(value);
                updateElementPosition(value);
            }

            function toggle() {
                var value = getValue();
                setElementValue(!value);

                $wrapper.stop().animate({
                    marginLeft: calculateElementLeftMargin(!value)
                }, 250);
            }

            function getValue() {
                return $element.hasClass('on');
            }

            function updateValue(value) {
                if (getValue() != value) {
                    setInitialValue(value);
                }
            }

            function setElementValue(value) {
                $element.toggleClass('on', value);
                $element.toggleClass('off', !value);
            }

            function updateElementPosition(value) {
                $wrapper.css('margin-left', calculateElementLeftMargin(value) + 'px');
            }

            function calculateElementLeftMargin(value) {
                return value ? 0 : $element.height() - $element.width();
            }

            return {
                setInitialValue: setInitialValue,
                updateValue: updateValue,
                toggle: toggle
            }
        },
        onClick: function (element, handler) {
            var $element = $(element),
                isMouseDownFired = false;

            $element.mousedown(function (event) {
                if (event.which != 1)
                    return;

                isMouseDownFired = true;
                handler();
            });

            $element.click(function () {
                if (isMouseDownFired) {
                    isMouseDownFired = false;
                    return;
                }

                handler();
            });
        }
    };

    ko.bindingHandlers.toggle = {
        init: function (element, valueAccessor) {
            var value = valueAccessor().value;

            $(element).click(function() {
                value(!value());
            });
        }
    };

    ko.bindingHandlers.dropdown = {
        cssClasses: {
            dropdown: 'dropdown',
            disabled: 'disabled',
            expanded: 'expanded',
            optionsList: 'dropdown-options-list',
            optionItem: 'dropdown-options-item',
            currentItem: 'dropdown-current-item',
            currentItemText: 'dropdown-current-item-text',
            indicatorHolder: 'dropdown-indicator-holder',
            indicator: 'dropdown-indicator'
        },
        init: function (element, valueAccessor) {
            var $element = $(element),
                cssClasses = ko.bindingHandlers.dropdown.cssClasses;

            $element.addClass(cssClasses.dropdown);

            var $currentItemElement = $('<div />')
                .addClass(cssClasses.currentItem)
                .appendTo($element);

            $('<div />')
                .addClass(cssClasses.currentItemText)
                .appendTo($currentItemElement);

            var $indicatorHolder = $('<div />')
                .addClass(cssClasses.indicatorHolder)
                .appendTo($currentItemElement);

            $('<span />')
                .addClass(cssClasses.indicator)
                .appendTo($indicatorHolder);

            $('<ul />')
                .addClass(cssClasses.optionsList)
                .appendTo($element);

            $currentItemElement.on('click', function (e) {
                if ($element.hasClass(cssClasses.disabled)) {
                    return;
                }

                $currentItemElement.toggleClass(cssClasses.expanded);
                e.stopPropagation();
            });

            var collapseHandler = function () {
                $currentItemElement.removeClass(cssClasses.expanded);
            };

            $('html').bind('click', collapseHandler);
            $(window).bind('blur', collapseHandler);

            ko.utils.domNodeDisposal.addDisposeCallback(element, function () {
                $('html').unbind('click', collapseHandler);
                $(window).unbind('blur', collapseHandler);
            });
        },
        update: function (element, valueAccessor) {
            var $element = $(element),
                cssClasses = ko.bindingHandlers.dropdown.cssClasses,

                $optionsListElement = $element.find('ul.' + cssClasses.optionsList),
                $currentItemTextElement = $element.find('div.' + cssClasses.currentItemText);


            var options = valueAccessor().options,
                optionsText = valueAccessor().optionsText,
                value = valueAccessor().value,
                optionsValue = valueAccessor().optionsValue,
                currentValue = ko.unwrap(value),
                disable = ko.unwrap(valueAccessor().disable);

            if (disable) {
                $element.toggleClass(cssClasses.disabled);
            } else {
                $element.removeClass(cssClasses.disabled);
            }

            $optionsListElement.empty();

            $.each(options, function (index, option) {
                if (option[optionsValue] == currentValue) {
                    $currentItemTextElement.text(option[optionsText]);
                    return;
                }

                $('<li />')
                    .addClass(cssClasses.optionItem)
                    .appendTo($optionsListElement)
                    .text(option[optionsText])
                    .on('click', function (e) {
                        value(option[optionsValue]);
                        $element.trigger('change');
                    });
            });
        }
    };

    ko.bindingHandlers.tabs = {
        init: function (element) {
            var $element = $(element),
                dataTabLink = 'data-tab-link',
                dataTab = 'data-tab',
                activeClass = 'active',
                $tabLinks = $element.find('[' + dataTabLink + ']'),
                $tabs = $element.find('[' + dataTab + ']');

            $tabs.hide();

            $tabLinks.first().addClass(activeClass);
            $tabs.first().show();

            $tabLinks.each(function (index, item) {
                var $item = $(item);
                $item.on('click', function () {
                    var key = $item.attr(dataTabLink),
                        currentContentTab = $element.find('[' + dataTab + '="' + key + '"]');
                    $tabLinks.removeClass(activeClass);
                    $item.addClass(activeClass);
                    $tabs.hide();
                    currentContentTab.show();
                });
            });

        }
    };

    ko.bindingHandlers.localize = {
        init: function (element, valueAccessor) {
            var $element = $(element),
                key = ko.unwrap(valueAccessor());

            $element.html(app.localize(key));
        }
    };

    ko.bindingHandlers.tip = {
        init: function(element, valueAccessor){
            var $element = $(element),
                value = valueAccessor(),

                key = ko.unwrap(value.key),
                triggerEvent = ko.unwrap(value.triggerEvent),
                maxWidth = ko.unwrap(value.maxWidth);

            $element.on(triggerEvent, function(){
                if(!$('.tooltip').length){
                    $('body').append('<div class="tooltip configure-tab" role="tooltip" style="max-width: ' + maxWidth + 'px;"><div class="tooltip-arrow"></div><div class="tooltip-text">' + app.localize(key) + '</div></div>');

                    var hintContentPosition = {
                        top: $element.offset().top - $('.tooltip').outerHeight() - 4,
                        left: $element.offset().left - ($('.tooltip').outerWidth() / 2) + ($element.outerWidth() / 2)
                    };
                    $('.tooltip').css({top: hintContentPosition.top, left: hintContentPosition.left}).addClass('shown');
                }else{
                    $('.tooltip').remove();
                }
            });
        }
    }
})();

(function (app) {

    app.TrackingDataModel = TrackingDataModel;
    app.LanguagesModel = LanguagesModel;
    app.MasteryScore = MasteryScore;
    app.PdfExport = PdfExport;
    app.Nps = Nps;
    app.Webhooks = Webhooks;

    function PdfExport(pdfExportSettings) {
        var that = this;

        that.enabled = ko.observable(false);
        that.getData = getData;
        init(pdfExportSettings);

        function init(pdfExportSettings) {
            if (!pdfExportSettings) {
                return;
            }

            that.enabled(pdfExportSettings.enabled);
        }

        function getData() {
            return {
                enabled: that.enabled()
            }
        }
    }

    function Nps(npsSettings) {
        var that = this;

        that.enabled = ko.observable(false);
        that.getData = getData;
        init(npsSettings);

        function init(npsSettings) {
            if (!npsSettings) {
                return;
            }

            that.enabled(npsSettings.enabled);
        }

        function getData() {
            return {
                enabled: that.enabled()
            }
        }
    }

    function Webhooks(webhooksSettings) {
        var that = this;
        var statuses = {
            notChecked: 'notChecked',
            success: 'success',
            error: 'error'
        };
        var _requestCheckData = {
            courseId: "courseId",
            learnerId: "example@example.com",
            score: 75,
            finishedOn: (new Date()).toISOString(),
            status: "passed"
        };

        that.url = ko.observable('');
        that.isChecking = ko.observable(false);
        that.checkStatus = ko.observable(statuses.notChecked);
        that.statuses = statuses;

        that.getData = getData;
        that.checkUrl = checkUrl;
        init(webhooksSettings);

        function init(webhooksSettings) {
            if (!webhooksSettings && !webhooksSettings.url) {
                return;
            }

            that.url(webhooksSettings.url);
        }

        function getData() {
            return {
                url: that.url()
            }
        }

        function checkUrl() {
            that.isChecking(true);
            
            $.ajax({
                url: that.url(),
                type: 'POST',
                cache: false,
                contentType: 'application/json',
                data: JSON.stringify(_requestCheckData)
            })
            .done(function() {
                that.checkStatus(statuses.success);
            })
            .fail(function() {
                that.checkStatus(statuses.error);
            })
            .always(function() {
                that.isChecking(false);
            });
        }
    }

    function TrackingDataModel(xApiSettings) {
        var that = this;

        that.advancedSettingsExpanded = ko.observable(false);

        that.enableXAPI = ko.observable(true);
        that.allowToSkipTracking = ko.observable(true);

        that.reportsOptions = [
            new DataTrackingOption('lrs', true),
            new DataTrackingOption('webhooks')
        ];

        that.lrsOptions = [
            new LrsOption('default', true),
            new LrsOption('custom')
        ];

        that.selectedLrs = ko.computed(function () {
            var selectedName = '';
            ko.utils.arrayForEach(that.lrsOptions, function (lrsOption) { //foreach because of we need to track selecting of all themes
                if (lrsOption.isSelected()) {
                    selectedName = lrsOption.name;
                }
            });
            return selectedName;
        }, that);

        that.customLrsEnabled = ko.computed(function () {
            return that.enableXAPI() && that.selectedLrs() != that.lrsOptions[0].name;
        });

        that.lrsUrl = ko.observable('');
        that.authenticationRequired = ko.observable(false);
        that.lapLogin = ko.observable();
        that.lapPassword = ko.observable();

        that.credentialsEnabled = ko.computed(function () {
            return that.customLrsEnabled() && that.authenticationRequired();
        });

        that.statements = {
            started: ko.observable(true),
            stopped: ko.observable(true),
            experienced: ko.observable(true),
            mastered: ko.observable(true),
            answered: ko.observable(true),
            passed: ko.observable(true),
            failed: ko.observable(true),
            progressed: ko.observable(true)
        };

        that.toggleAdvancedSettings = toggleAdvancedSettings;
        that.selectReports = selectReports;
        that.selectLrs = selectLrs;
        that.selectLrsByName = selectLrsByName;
        that.setStatements = setStatements;
        that.setCustomLrsSettings = setCustomLrsSettings;
        that.getData = getData;

        init(xApiSettings);

        return that;

        function init(xApiSettings) {
            if (!xApiSettings) {
                return;
            }

            that.enableXAPI(xApiSettings.enabled);
            that.allowToSkipTracking(!xApiSettings.required);

            if (xApiSettings.selectedLrs) {
                that.selectLrsByName(xApiSettings.selectedLrs);
            }

            if (xApiSettings.lrs) {
                that.setCustomLrsSettings(xApiSettings.lrs);
            }

            if (xApiSettings.allowedVerbs) {
                that.setStatements(xApiSettings.allowedVerbs);
            }
        }

        function toggleAdvancedSettings() {
            that.advancedSettingsExpanded(!that.advancedSettingsExpanded());
        }

        function selectReports(reportsOption) {
            ko.utils.arrayForEach(that.reportsOptions, function (reportsOption) {
                reportsOption.isSelected(false);
            });
            reportsOption.isSelected(true);
        }

        function selectLrs(lrs) {
            ko.utils.arrayForEach(that.lrsOptions, function (lrsOptions) {
                lrsOptions.isSelected(false);
            });
            lrs.isSelected(true);
        }

        function selectLrsByName(name) {
            ko.utils.arrayForEach(that.lrsOptions, function (lrsOption) {
                lrsOption.isSelected(lrsOption.name === name);
            });
        }

        function setStatements(statements) {
            ko.utils.objectForEach(that.statements, function (key, value) {
                value(statements.indexOf(key) > -1);
            });
        }

        function setCustomLrsSettings(customLrsSettings) {
            that.lrsUrl(customLrsSettings.uri || '');
            that.authenticationRequired(customLrsSettings.authenticationRequired || false);
            that.lapLogin(customLrsSettings.credentials.username || '');
            that.lapPassword(customLrsSettings.credentials.password || '');
        }

        function getData() {
            var allowedVerbs = [];

            ko.utils.objectForEach(that.statements, function (key, value) {
                if (value()) {
                    allowedVerbs.push(key);
                }
            });

            return {
                enabled: that.enableXAPI(),
                required: !that.allowToSkipTracking(),
                selectedLrs: that.selectedLrs(),
                lrs: {
                    uri: that.lrsUrl().trim(),
                    authenticationRequired: that.authenticationRequired(),
                    credentials: {
                        username: that.lapLogin().trim(),
                        password: that.lapPassword().trim()
                    }
                },
                allowedVerbs: allowedVerbs
            };
        }

        function DataTrackingOption(name, isSelected) {
            var that = this;

            that.name = name;
            that.isSelected = ko.observable(isSelected);

            return that;
        }

        function LrsOption(name, isSelected) {
            var that = this;

            that.name = name;
            that.isSelected = ko.observable(isSelected === true);

            return that;
        }
    }

    function LanguagesModel(languages, languagesSettings) {
        var that = this;

        var customLanguageCode = 'xx';
        var defaultLanguageCode = 'en';

        that.languages = [];

        var _selectedLanguageCode = ko.observable((languagesSettings && languagesSettings.selected) ? languagesSettings.selected : null);
        that.selectedLanguageCode = ko.pureComputed({
            read: function () {
                return _selectedLanguageCode();
            },
            write: function (value) {
                var language = getLanguage(value);

                if (!language) {
                    return;
                }

                if (language.isLoaded) {
                    _selectedLanguageCode(value);
                    return;
                }

                that.isLanguageLoading(true);
                language.load().done(function () {
                    _selectedLanguageCode(value);
                    that.isLanguageLoading(false);
                });
            }
        });
        that.selectedLanguageTranslations = ko.pureComputed(function () {
            var language = getLanguage(that.selectedLanguageCode());
            return language ? language.getTranslations() : null;
        });

        that.isLanguageLoading = ko.observable(false);

        that.isLanguageEditable = isLanguageEditable;
        that.getCustomTranslations = getCustomTranslations;

        that.getData = getData;

        init(languages, languagesSettings);

        return that;

        function sortByLanguageName(a, b){
            var aName = a.name.toLowerCase();
            var bName = b.name.toLowerCase(); 
            return ((aName < bName) ? -1 : ((aName > bName) ? 1 : 0));
        }

        function init(languages, languagesSettings) {
            ko.utils.arrayForEach(languages || [], function (language) {
                addLanguage(new LanguageModel(language.code, app.localize(language.code), language.url));
            });

            that.languages.sort(sortByLanguageName);

            var defaultLanguage = getLanguage(defaultLanguageCode);
            var customLanguage = new LanguageModel(customLanguageCode, app.localize(customLanguageCode), defaultLanguage ? defaultLanguage.resourcesUrl : null, languagesSettings ? languagesSettings.customTranslations : null);

            addLanguage(customLanguage);

            var selectedLanguageCode = (languagesSettings && languagesSettings.selected) ? languagesSettings.selected : defaultLanguageCode;
            that.selectedLanguageCode(selectedLanguageCode);
        }

        function isLanguageEditable() {
            return that.selectedLanguageCode() === customLanguageCode;
        }

        function getCustomTranslations() {
            var customLanguage = getLanguage(customLanguageCode);
            if (customLanguage) {
                return customLanguage.getNotMappedTranslations();
            }
            return [];
        }

        function addLanguage(language) {
            that.languages.push(language);
        }

        function getLanguage(code) {
            return ko.utils.arrayFirst(that.languages, function (language) {
                return language.code === code;
            });
        }

        function getData() {
            var settingsData = {};

            if (that.selectedLanguageCode()) {
                settingsData.selected = that.selectedLanguageCode();
            }

            var customTranslations = getCustomTranslations();
            if (customTranslations && !$.isEmptyObject(customTranslations)) {
                settingsData.customTranslations = customTranslations;
            }

            return settingsData;
        }

        function LanguageModel(code, name, resourcesUrl, translations) {
            var that = this,
                _mappedTranslations = [],
                _customTranslations = translations;

            that.code = code;
            that.name = name;

            that.isLoaded = false;
            that.load = load;
            that.resourcesUrl = resourcesUrl;

            that.setTranslations = setTranslations;
            that.getTranslations = getTranslations;
            that.getNotMappedTranslations = getNotMappedTranslations;

            if (translations) {
                that.setTranslations(translations);
            }

            function setTranslations(translations) {
                _mappedTranslations = map(translations);
            }

            function getTranslations() {
                return _mappedTranslations;
            }

            function getNotMappedTranslations() {
                return unmap(_mappedTranslations);
            }

            function load() {
                return loadLanguageResources(that.resourcesUrl).then(function (resources) {
                    if (_customTranslations) {
                        var translationsList = {};
                        $.each(resources, function (key, value) {
                            translationsList[key] = typeof _customTranslations[key] == "string" ? _customTranslations[key] : value;
                        });
                        that.setTranslations(translationsList);
                    } else {
                        that.setTranslations(resources);
                    }
                    that.isLoaded = true;
                });
            }

            function loadLanguageResources(url) {
                return $.ajax({
                    url: url,
                    dataType: 'json',
                    contentType: 'application/json'
                });
            }

            function map(translationsObject) {
                var arr = [];

                if (translationsObject) {
                    Object.keys(translationsObject).forEach(function (key) {
                        arr.push({
                            key: key,
                            value: translationsObject[key]
                        });
                    });
                }

                return arr;
            }

            function unmap(translationsArray) {
                var translationsObj = {};

                if (translationsArray) {
                    translationsArray.forEach(function (translation) {
                        translationsObj[translation.key] = translation.value;
                    });
                }

                return translationsObj;
            }
        }
    }

    function MasteryScore(masteryScoreSettings) {
        var that = this;

        that.score = ko.observable(masteryScoreSettings && masteryScoreSettings.score || 100);
        that.isOverall = ko.observable(!!(masteryScoreSettings && masteryScoreSettings.isOverall));
        that.getData = getData;

        return that;

        function getData() {
            return {
                score: that.score(),
                isOverall: that.isOverall()
            };
        };
    }

})(window.app = window.app || {});
(function (app) {

    var
      currentSettings = null;

    var viewModel = {
        isError: ko.observable(false),

        trackingData: null,
        masteryScore: null,
        languages: null,
        pdfExport: null,
        nps: null,
        webhooks: null,
        authorsBio: ko.observable(false),
        showConfirmationPopup: ko.observable(true),
        allowContentPagesScoring: ko.observable(false),
        allowCrossDeviceSaving: ko.observable(true),
        allowSocialLogin: ko.observable(true),
        allowCertificateDownload: ko.observable(false),
        copyright: ko.observable(''),
        copyrightPlaceholder: ko.observable(''),

        allowNpsSettings: ko.observable(true),
        allowxApiSettings: ko.observable(true),
        allowToSkipTrackingSettings: ko.observable(true),
        allowCrossDeviceSavingSettings: ko.observable(true),
        allowContentPagesScoringSettings: ko.observable(true),
        allowLoginViaSocialMediaSettings: ko.observable(true)
    };

    viewModel.getCurrentSettingsData = function (settings) {
        return $.extend({}, settings || currentSettings, {
            pdfExport: viewModel.pdfExport.getData(),
            nps: viewModel.nps.getData(),
            webhooks: viewModel.webhooks.getData(),
            allowAuthorsBio: viewModel.authorsBio(),
            xApi: viewModel.trackingData.getData(),
            masteryScore: viewModel.masteryScore.getData(),
            languages: viewModel.languages.getData(),
            showConfirmationPopup: viewModel.showConfirmationPopup(),
            allowContentPagesScoring: viewModel.allowContentPagesScoring(),
            allowCrossDeviceSaving: viewModel.allowCrossDeviceSaving(),
            allowCertificateDownload: viewModel.allowCertificateDownload(),
            copyright: viewModel.copyright(),

            allowNpsSettings: viewModel.allowNpsSettings(),
            allowxApiSettings: viewModel.allowxApiSettings(),
            allowLoginViaSocialMedia: viewModel.allowSocialLogin(),
            allowToSkipTrackingSettings: viewModel.allowToSkipTrackingSettings(),
            allowCrossDeviceSavingSettings: viewModel.allowCrossDeviceSavingSettings(),
            allowContentPagesScoringSettings: viewModel.allowContentPagesScoringSettings(),
            allowLoginViaSocialMediaSettings: viewModel.allowLoginViaSocialMediaSettings()
        });
    };

    viewModel.saveChanges = function () {
        var settings = viewModel.getCurrentSettingsData(),
          newSettings = JSON.stringify(settings);

        if (JSON.stringify(currentSettings) === newSettings) {
            return;
        }

        window.egApi.saveConfigurationSettings(newSettings, app.localize('changes are saved'), app.localize('changes are not saved'))
          .done(function () {
              currentSettings = settings;
          });
    };

    viewModel.onBeforeCertificateDownloadUpdated = function (newValue) {
        if (newValue && !viewModel.canUpdateAllowCertificateDownload){
            window.egApi.showCertificatesUpgradePopup();
            return false;
        }

        return true;
    };

    viewModel.init = function () {
        var api = window.egApi;
        return api.init().then(function () {
            var manifest = api.getManifest(),
              settings = api.getConfigurationSettings(),
              user = api.getUser();

            var defaultTemplateSettings = manifest && manifest.defaultTemplateSettings ? manifest.defaultTemplateSettings : {};

            viewModel.pdfExport = new app.PdfExport(settings.pdfExport || defaultTemplateSettings.pdfExport);
            viewModel.nps = new app.Nps(settings.nps || defaultTemplateSettings.nps);
            viewModel.webhooks = new app.Webhooks(settings.webhooks || defaultTemplateSettings.webhooks);
            viewModel.masteryScore = new app.MasteryScore(settings.masteryScore || defaultTemplateSettings.masteryScore);
            viewModel.trackingData = new app.TrackingDataModel(settings.xApi || defaultTemplateSettings.xApi);

            viewModel.languages = new app.LanguagesModel(manifest.languages, settings.languages || defaultTemplateSettings.languages);
            viewModel.canUpdateAllowCertificateDownload = user.hasTeamAccess();

            initField(viewModel.showConfirmationPopup, 'showConfirmationPopup');
            initField(viewModel.allowContentPagesScoring, 'allowContentPagesScoring');
            initField(viewModel.allowCrossDeviceSaving, 'allowCrossDeviceSaving');
            initField(viewModel.authorsBio, 'allowAuthorsBio');
            initField(viewModel.allowCertificateDownload, 'allowCertificateDownload');
            initField(viewModel.copyright, 'copyright', localizeCopyright);
            viewModel.copyrightPlaceholder(localizeCopyright(app.localize('copyrightPlaceholder')));

            initField(viewModel.allowNpsSettings, 'allowNpsSettings');
            initField(viewModel.allowxApiSettings, 'allowxApiSettings');
            initField(viewModel.allowSocialLogin, 'allowLoginViaSocialMedia');
            initField(viewModel.allowToSkipTrackingSettings, 'allowToSkipTrackingSettings');
            initField(viewModel.allowCrossDeviceSavingSettings, 'allowCrossDeviceSavingSettings');
            initField(viewModel.allowContentPagesScoringSettings, 'allowContentPagesScoringSettings');
            initField(viewModel.allowLoginViaSocialMediaSettings, 'allowLoginViaSocialMediaSettings');

            currentSettings = viewModel.getCurrentSettingsData(settings);

            function initField(field, property, handler) {
                var val = null;
                if (settings.hasOwnProperty(property)) {
                    val = settings[property];
                } else if (defaultTemplateSettings.hasOwnProperty(property)) {
                    val = defaultTemplateSettings[property];
                }

                if (val !== null) {
                    field(handler ? handler(val) : val);
                }
            }

        }).fail(function () {
            viewModel.isError(true);
        });
    };

    viewModel.init().always(function () {
        $(document).ready(function () {
            ko.applyBindings(viewModel, $('.settings-container')[0]);
            $(window).on('blur', viewModel.saveChanges);
        });
    });

    function localizeCopyright(copyrightText) {
        return copyrightText.replace('{year}', new Date().getFullYear());
    }

})(window.app = window.app || {});
